/*
 * Copyright (C) 2008 Markus Gross <xsdnyd@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public
 * License along with this program; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
package ui.graphical.forms;

import global.conversion.DataProvider;
import global.misc.Controller;
import global.misc.FileDialogFilter;
import global.misc.ImageTransformationInfo;
import global.misc.Info;
import global.misc.OutputInfo;
import global.misc.UserInterface;
import global.misc.WizardModel;
import java.awt.Color;
import java.awt.Font;
import java.awt.GraphicsEnvironment;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.Enumeration;
import java.util.ResourceBundle;
import javax.swing.AbstractButton;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

/**
 * This class implements the gui interface.
 * @author xsdnyd
 */
public class JMain extends javax.swing.JFrame implements UserInterface {

    /** The application controller. */
    private Controller controller;
    /** The language ressource which provides translated Strings. */
    private static final ResourceBundle lang =
            java.util.ResourceBundle.getBundle("global/resources/lang");

    /**
     * Creates new form JMain. Initializes some gui controls.
     */
    public JMain() {
        initComponents();
        controller = new Controller(this);
        tpWizard.setModel(new WizardModel(controller));
        for (String font : GraphicsEnvironment.getLocalGraphicsEnvironment().
                getAvailableFontFamilyNames())
            cbFont.addItem(font);
        btngrpDesign.add(rbBinary);
        btngrpDesign.add(rbNumbers);
        btngrpDesign.add(rbLowercase);
        btngrpDesign.add(rbUppercase);
        btngrpDesign.add(rbCharacters);
        btngrpDesign.add(rbCustomText);
        btngrpDesign.add(rbBrightness);
        btngrpOutputFormat.add(rbHTML);
        btngrpOutputFormat.add(rbHTMLCSS);
        btngrpOutputFormat.add(rbRTF);
        btngrpOutputFormat.add(rbTXT);
        btngrpOutputFormat.add(rbBMP);
        btngrpOutputFormat.add(rbJPG);
        btngrpOutputFormat.add(rbPNG);
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btngrpOutputFormat = new javax.swing.ButtonGroup();
        btngrpDesign = new javax.swing.ButtonGroup();
        lblWelcome = new javax.swing.JLabel();
        tpWizard = new javax.swing.JTabbedPane();
        pnlInput = new javax.swing.JPanel();
        lblSelectInput = new javax.swing.JLabel();
        edtInput = new javax.swing.JTextField();
        btnBrowseInput = new javax.swing.JButton();
        pnlPreview = new ui.graphical.controls.JImagePanel();
        lblDescPreview = new javax.swing.JLabel();
        lblDescSize = new javax.swing.JLabel();
        lblInfoSize = new javax.swing.JLabel();
        lblDescAspectRatio = new javax.swing.JLabel();
        lblInfoAspectRatio = new javax.swing.JLabel();
        lblModifyInput = new javax.swing.JLabel();
        chkResize = new javax.swing.JCheckBox();
        edtWidth = new javax.swing.JTextField();
        lblDescTimes = new javax.swing.JLabel();
        edtHeight = new javax.swing.JTextField();
        chkQuantize = new javax.swing.JCheckBox();
        edtColorCount = new javax.swing.JTextField();
        chkGrayscale = new javax.swing.JCheckBox();
        lblColorNotice = new javax.swing.JLabel();
        chkAspectRatio = new javax.swing.JCheckBox();
        pnlDesign = new javax.swing.JPanel();
        lblPattern = new javax.swing.JLabel();
        rbBinary = new javax.swing.JRadioButton();
        rbNumbers = new javax.swing.JRadioButton();
        rbLowercase = new javax.swing.JRadioButton();
        rbUppercase = new javax.swing.JRadioButton();
        rbCharacters = new javax.swing.JRadioButton();
        lblTo = new javax.swing.JLabel();
        rbCustomText = new javax.swing.JRadioButton();
        edtCustomText = new javax.swing.JTextField();
        btnBrowseText = new javax.swing.JButton();
        chkCustomTextRandom = new javax.swing.JCheckBox();
        rbBrightness = new javax.swing.JRadioButton();
        edtBrightness = new javax.swing.JTextField();
        lblDescBrightness = new javax.swing.JLabel();
        lblFont = new javax.swing.JLabel();
        cbFont = new javax.swing.JComboBox();
        lblFontSize = new javax.swing.JLabel();
        edtFontSize = new javax.swing.JTextField();
        lblBackground = new javax.swing.JLabel();
        lblPreview = new javax.swing.JLabel();
        cpBackground = new ui.graphical.controls.JColorPanel();
        chkBold = new javax.swing.JCheckBox();
        edtLowerRange = new javax.swing.JTextField();
        edtUpperRange = new javax.swing.JTextField();
        lblFontUnit = new javax.swing.JLabel();
        pnlOutputFormat = new javax.swing.JPanel();
        lblOutputFormat = new javax.swing.JLabel();
        rbHTML = new javax.swing.JRadioButton();
        rbHTMLCSS = new javax.swing.JRadioButton();
        rbRTF = new javax.swing.JRadioButton();
        rbTXT = new javax.swing.JRadioButton();
        lblDetails = new javax.swing.JLabel();
        slDetails = new javax.swing.JSlider();
        lblTextFormats = new javax.swing.JLabel();
        lblImageFormats = new javax.swing.JLabel();
        rbBMP = new javax.swing.JRadioButton();
        rbJPG = new javax.swing.JRadioButton();
        rbPNG = new javax.swing.JRadioButton();
        lblSelectOutput = new javax.swing.JLabel();
        edtOutput = new javax.swing.JTextField();
        btnBrowseOutput = new javax.swing.JButton();
        slQuality = new javax.swing.JSlider();
        lblQuality = new javax.swing.JLabel();
        pnlOutput = new javax.swing.JPanel();
        lblSummary = new javax.swing.JLabel();
        spSummary = new javax.swing.JScrollPane();
        taSummary = new javax.swing.JTextArea();
        btnGenerateASCII = new javax.swing.JButton();
        btnCancelASCII = new javax.swing.JButton();
        lblProgress = new javax.swing.JLabel();
        pbProgress = new javax.swing.JProgressBar();
        btnExit = new javax.swing.JButton();
        btnNext = new javax.swing.JButton();
        btnBack = new javax.swing.JButton();
        lblCopyright = new ui.graphical.controls.JCopyrightLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle(Info.APP_NAME + " " + Info.APP_VERSION);
        setResizable(false);

        lblWelcome.setText(lang.getString("Welcome")); // NOI18N

        tpWizard.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                tpWizardStateChanged(evt);
            }
        });

        lblSelectInput.setText(lang.getString("Step_Select_Input")); // NOI18N

        edtInput.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                edtInputFocusLost(evt);
            }
        });
        edtInput.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                edtInputKeyPressed(evt);
            }
        });

        btnBrowseInput.setText("...");
        btnBrowseInput.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBrowseInputActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout pnlPreviewLayout = new javax.swing.GroupLayout(pnlPreview);
        pnlPreview.setLayout(pnlPreviewLayout);
        pnlPreviewLayout.setHorizontalGroup(
            pnlPreviewLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 90, Short.MAX_VALUE)
        );
        pnlPreviewLayout.setVerticalGroup(
            pnlPreviewLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 88, Short.MAX_VALUE)
        );

        lblDescPreview.setText(lang.getString("Preview")); // NOI18N

        lblDescSize.setText(lang.getString("Size")); // NOI18N

        lblInfoSize.setText("0 x 0");

        lblDescAspectRatio.setText(lang.getString("Aspect_Ratio")); // NOI18N

        lblInfoAspectRatio.setText("0");

        lblModifyInput.setText(lang.getString("Step_Modify_Input")); // NOI18N

        chkResize.setText(lang.getString("Resize_Image")); // NOI18N
        chkResize.setEnabled(false);
        chkResize.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkResizeItemStateChanged(evt);
            }
        });

        edtWidth.setText("0");
        edtWidth.setEnabled(false);
        edtWidth.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                edtWidthFocusLost(evt);
            }
        });
        edtWidth.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                edtWidthKeyReleased(evt);
            }
        });

        lblDescTimes.setText("x");

        edtHeight.setText("0");
        edtHeight.setEnabled(false);
        edtHeight.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                edtHeightFocusLost(evt);
            }
        });
        edtHeight.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyReleased(java.awt.event.KeyEvent evt) {
                edtHeightKeyReleased(evt);
            }
        });

        chkQuantize.setText(lang.getString("Change_Color_Count")); // NOI18N
        chkQuantize.setEnabled(false);
        chkQuantize.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkQuantizeItemStateChanged(evt);
            }
        });

        edtColorCount.setText("256");
        edtColorCount.setEnabled(false);
        edtColorCount.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                edtColorCountFocusLost(evt);
            }
        });

        chkGrayscale.setText(lang.getString("Grayscale")); // NOI18N
        chkGrayscale.setEnabled(false);

        lblColorNotice.setText(lang.getString("Format_Notice")); // NOI18N

        chkAspectRatio.setSelected(true);
        chkAspectRatio.setText(lang.getString("Keep_Aspect_Ratio")); // NOI18N
        chkAspectRatio.setEnabled(false);
        chkAspectRatio.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkAspectRatioItemStateChanged(evt);
            }
        });

        javax.swing.GroupLayout pnlInputLayout = new javax.swing.GroupLayout(pnlInput);
        pnlInput.setLayout(pnlInputLayout);
        pnlInputLayout.setHorizontalGroup(
            pnlInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlInputLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlInputLayout.createSequentialGroup()
                        .addComponent(chkGrayscale)
                        .addContainerGap())
                    .addGroup(pnlInputLayout.createSequentialGroup()
                        .addComponent(chkQuantize)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(edtColorCount, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())
                    .addGroup(pnlInputLayout.createSequentialGroup()
                        .addGroup(pnlInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblSelectInput)
                            .addGroup(pnlInputLayout.createSequentialGroup()
                                .addComponent(lblDescSize)
                                .addGap(45, 45, 45)
                                .addGroup(pnlInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(pnlPreview, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addGroup(pnlInputLayout.createSequentialGroup()
                                        .addComponent(lblInfoSize, javax.swing.GroupLayout.PREFERRED_SIZE, 129, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(lblDescAspectRatio, javax.swing.GroupLayout.DEFAULT_SIZE, 128, Short.MAX_VALUE)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                        .addComponent(lblInfoAspectRatio, javax.swing.GroupLayout.PREFERRED_SIZE, 172, javax.swing.GroupLayout.PREFERRED_SIZE)
                                        .addGap(157, 157, 157)))))
                        .addContainerGap())
                    .addGroup(pnlInputLayout.createSequentialGroup()
                        .addComponent(lblDescPreview, javax.swing.GroupLayout.DEFAULT_SIZE, 99, Short.MAX_VALUE)
                        .addGap(584, 584, 584))
                    .addGroup(pnlInputLayout.createSequentialGroup()
                        .addComponent(lblModifyInput)
                        .addContainerGap(371, Short.MAX_VALUE))
                    .addGroup(pnlInputLayout.createSequentialGroup()
                        .addComponent(chkResize)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(edtWidth, javax.swing.GroupLayout.PREFERRED_SIZE, 54, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(lblDescTimes)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(edtHeight, javax.swing.GroupLayout.PREFERRED_SIZE, 54, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(chkAspectRatio)
                        .addGap(292, 292, 292))
                    .addGroup(pnlInputLayout.createSequentialGroup()
                        .addGroup(pnlInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblColorNotice)
                            .addComponent(edtInput, javax.swing.GroupLayout.DEFAULT_SIZE, 634, Short.MAX_VALUE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBrowseInput, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addContainerGap())))
        );
        pnlInputLayout.setVerticalGroup(
            pnlInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlInputLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblSelectInput)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnBrowseInput)
                    .addComponent(edtInput, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlInputLayout.createSequentialGroup()
                        .addGroup(pnlInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(lblDescSize)
                            .addComponent(lblInfoSize, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lblDescAspectRatio))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(pnlInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(lblDescPreview)
                            .addComponent(pnlPreview, javax.swing.GroupLayout.PREFERRED_SIZE, 88, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(35, 35, 35)
                        .addComponent(lblModifyInput)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(pnlInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(chkResize)
                            .addComponent(edtWidth, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(lblDescTimes)
                            .addComponent(edtHeight, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(chkAspectRatio))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addGroup(pnlInputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                            .addComponent(chkQuantize)
                            .addComponent(edtColorCount, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(chkGrayscale))
                    .addComponent(lblInfoAspectRatio, javax.swing.GroupLayout.PREFERRED_SIZE, 14, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(lblColorNotice)
                .addGap(54, 54, 54))
        );

        tpWizard.addTab(lang.getString("Tab_Input"), pnlInput); // NOI18N

        lblPattern.setText(lang.getString("Step_Select_Ascii")); // NOI18N

        rbBinary.setSelected(true);
        rbBinary.setText(lang.getString("Ascii_Binary")); // NOI18N

        rbNumbers.setText(lang.getString("Ascii_Numbers")); // NOI18N

        rbLowercase.setText(lang.getString("Ascii_Lowercase_Chars")); // NOI18N

        rbUppercase.setText(lang.getString("Ascii_Uppercase_Chars")); // NOI18N

        rbCharacters.setText(lang.getString("Ascii_Range_Chars")); // NOI18N
        rbCharacters.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                rbCharactersItemStateChanged(evt);
            }
        });

        lblTo.setText(lang.getString("To")); // NOI18N

        rbCustomText.setText(lang.getString("Ascii_Custom_Text")); // NOI18N
        rbCustomText.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                rbCustomTextItemStateChanged(evt);
            }
        });

        edtCustomText.setText("JASCiiArt");
        edtCustomText.setEnabled(false);
        edtCustomText.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                edtCustomTextFocusLost(evt);
            }
        });

        btnBrowseText.setText("...");
        btnBrowseText.setEnabled(false);
        btnBrowseText.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBrowseTextActionPerformed(evt);
            }
        });

        chkCustomTextRandom.setText(lang.getString("Select_Random")); // NOI18N
        chkCustomTextRandom.setEnabled(false);

        rbBrightness.setText(lang.getString("Ascii_Brightness_Pattern")); // NOI18N
        rbBrightness.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                rbBrightnessItemStateChanged(evt);
            }
        });

        edtBrightness.setText("JASCiiArt");
        edtBrightness.setEnabled(false);
        edtBrightness.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                edtBrightnessFocusLost(evt);
            }
        });

        lblDescBrightness.setText(lang.getString("Ascii_Brightness_Pattern_Notice")); // NOI18N

        lblFont.setText(lang.getString("Step_Select_Font")); // NOI18N

        cbFont.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                cbFontItemStateChanged(evt);
            }
        });

        lblFontSize.setText(lang.getString("Size")); // NOI18N

        edtFontSize.setText("11");
        edtFontSize.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                edtFontSizeFocusLost(evt);
            }
        });

        lblBackground.setText(lang.getString("Step_Select_Background")); // NOI18N

        lblPreview.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
        lblPreview.setText(lang.getString("Preview_Text")); // NOI18N

        javax.swing.GroupLayout cpBackgroundLayout = new javax.swing.GroupLayout(cpBackground);
        cpBackground.setLayout(cpBackgroundLayout);
        cpBackgroundLayout.setHorizontalGroup(
            cpBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 232, Short.MAX_VALUE)
        );
        cpBackgroundLayout.setVerticalGroup(
            cpBackgroundLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 41, Short.MAX_VALUE)
        );

        chkBold.setText(lang.getString("Bold")); // NOI18N
        chkBold.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                chkBoldItemStateChanged(evt);
            }
        });

        edtLowerRange.setText("123");
        edtLowerRange.setEnabled(false);
        edtLowerRange.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                edtLowerRangeFocusLost(evt);
            }
        });

        edtUpperRange.setText("254");
        edtUpperRange.setEnabled(false);
        edtUpperRange.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                edtUpperRangeFocusLost(evt);
            }
        });

        lblFontUnit.setText(lang.getString("Point")); // NOI18N

        javax.swing.GroupLayout pnlDesignLayout = new javax.swing.GroupLayout(pnlDesign);
        pnlDesign.setLayout(pnlDesignLayout);
        pnlDesignLayout.setHorizontalGroup(
            pnlDesignLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlDesignLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlDesignLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlDesignLayout.createSequentialGroup()
                        .addGap(21, 21, 21)
                        .addComponent(lblDescBrightness))
                    .addComponent(rbLowercase)
                    .addComponent(rbNumbers)
                    .addComponent(rbBinary)
                    .addComponent(lblPattern)
                    .addComponent(rbUppercase)
                    .addGroup(pnlDesignLayout.createSequentialGroup()
                        .addGroup(pnlDesignLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(rbCharacters)
                            .addComponent(rbCustomText)
                            .addComponent(rbBrightness))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(pnlDesignLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(pnlDesignLayout.createSequentialGroup()
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(edtLowerRange, javax.swing.GroupLayout.PREFERRED_SIZE, 46, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(lblTo)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(edtUpperRange, javax.swing.GroupLayout.PREFERRED_SIZE, 48, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(pnlDesignLayout.createSequentialGroup()
                                .addGroup(pnlDesignLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                                    .addComponent(edtBrightness, javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(edtCustomText, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 273, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btnBrowseText, javax.swing.GroupLayout.PREFERRED_SIZE, 29, javax.swing.GroupLayout.PREFERRED_SIZE)))
                        .addGap(14, 14, 14)
                        .addComponent(chkCustomTextRandom))
                    .addComponent(lblFont)
                    .addGroup(pnlDesignLayout.createSequentialGroup()
                        .addGroup(pnlDesignLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlDesignLayout.createSequentialGroup()
                                .addComponent(lblBackground)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(cpBackground, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlDesignLayout.createSequentialGroup()
                                .addComponent(cbFont, javax.swing.GroupLayout.PREFERRED_SIZE, 208, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(lblFontSize)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(edtFontSize, javax.swing.GroupLayout.PREFERRED_SIZE, 41, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addGap(2, 2, 2)
                                .addComponent(lblFontUnit)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(chkBold)))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED, 63, Short.MAX_VALUE)
                        .addComponent(lblPreview, javax.swing.GroupLayout.PREFERRED_SIZE, 180, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        pnlDesignLayout.setVerticalGroup(
            pnlDesignLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlDesignLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblPattern)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(rbBinary)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(rbNumbers)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(rbLowercase)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(rbUppercase)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(pnlDesignLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(rbCharacters)
                    .addComponent(lblTo)
                    .addComponent(edtLowerRange, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(edtUpperRange, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(pnlDesignLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(rbCustomText)
                    .addComponent(chkCustomTextRandom)
                    .addComponent(edtCustomText, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(btnBrowseText))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(pnlDesignLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(rbBrightness)
                    .addComponent(edtBrightness, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(lblDescBrightness)
                .addGap(18, 18, 18)
                .addComponent(lblFont)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlDesignLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(cbFont, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(lblFontSize)
                    .addComponent(edtFontSize, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(chkBold)
                    .addComponent(lblPreview)
                    .addComponent(lblFontUnit))
                .addGap(18, 18, 18)
                .addGroup(pnlDesignLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblBackground)
                    .addComponent(cpBackground, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(56, 56, 56))
        );

        tpWizard.addTab(lang.getString("Tab_Design"), pnlDesign); // NOI18N

        lblOutputFormat.setText(lang.getString("Step_Select_Output_Format")); // NOI18N

        rbHTML.setSelected(true);
        rbHTML.setText(lang.getString("Output_HTML")); // NOI18N
        rbHTML.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                rbHTMLItemStateChanged(evt);
            }
        });

        rbHTMLCSS.setText(lang.getString("Output_CSSHTML")); // NOI18N
        rbHTMLCSS.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                rbHTMLCSSItemStateChanged(evt);
            }
        });

        rbRTF.setText(lang.getString("Output_RTF")); // NOI18N
        rbRTF.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                rbRTFItemStateChanged(evt);
            }
        });

        rbTXT.setText(lang.getString("Output_TXT")); // NOI18N
        rbTXT.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                rbTXTItemStateChanged(evt);
            }
        });

        lblDetails.setText(lang.getString("Details")); // NOI18N
        lblDetails.setVisible(false);

        slDetails.setMajorTickSpacing(1);
        slDetails.setMaximum(10);
        slDetails.setMinimum(1);
        slDetails.setPaintLabels(true);
        slDetails.setPaintTicks(true);
        slDetails.setSnapToTicks(true);
        slDetails.setValue(5);
        slDetails.setVisible(false);

        lblTextFormats.setText(lang.getString("Text_Formats")); // NOI18N

        lblImageFormats.setText(lang.getString("Image_Formats")); // NOI18N

        rbBMP.setText(lang.getString("Output_BMP")); // NOI18N
        rbBMP.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                rbBMPItemStateChanged(evt);
            }
        });

        rbJPG.setText(lang.getString("Output_JPG")); // NOI18N
        rbJPG.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                rbJPGItemStateChanged(evt);
            }
        });

        rbPNG.setText(lang.getString("Output_PNG")); // NOI18N
        rbPNG.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                rbPNGItemStateChanged(evt);
            }
        });

        lblSelectOutput.setText(lang.getString("Step_Select_Output")); // NOI18N

        edtOutput.addFocusListener(new java.awt.event.FocusAdapter() {
            public void focusLost(java.awt.event.FocusEvent evt) {
                edtOutputFocusLost(evt);
            }
        });

        btnBrowseOutput.setText("...");
        btnBrowseOutput.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBrowseOutputActionPerformed(evt);
            }
        });

        slQuality.setMajorTickSpacing(1);
        slQuality.setMaximum(10);
        slQuality.setMinimum(1);
        slQuality.setPaintLabels(true);
        slQuality.setPaintTicks(true);
        slQuality.setSnapToTicks(true);
        slQuality.setValue(9);
        slQuality.setVisible(false);

        lblQuality.setText(lang.getString("Quality")); // NOI18N
        lblQuality.setVisible(false);

        javax.swing.GroupLayout pnlOutputFormatLayout = new javax.swing.GroupLayout(pnlOutputFormat);
        pnlOutputFormat.setLayout(pnlOutputFormatLayout);
        pnlOutputFormatLayout.setHorizontalGroup(
            pnlOutputFormatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlOutputFormatLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlOutputFormatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(pnlOutputFormatLayout.createSequentialGroup()
                        .addGap(12, 12, 12)
                        .addGroup(pnlOutputFormatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(rbHTML)
                            .addComponent(lblTextFormats)
                            .addComponent(rbHTMLCSS)
                            .addGroup(pnlOutputFormatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlOutputFormatLayout.createSequentialGroup()
                                    .addGroup(pnlOutputFormatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                        .addComponent(rbRTF)
                                        .addGroup(pnlOutputFormatLayout.createSequentialGroup()
                                            .addComponent(rbTXT)
                                            .addGap(44, 44, 44)
                                            .addComponent(lblDetails)))
                                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                    .addComponent(slDetails, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlOutputFormatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addGroup(pnlOutputFormatLayout.createSequentialGroup()
                                        .addGroup(pnlOutputFormatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                            .addComponent(rbBMP)
                                            .addComponent(rbJPG))
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 64, Short.MAX_VALUE)
                                        .addComponent(lblQuality)
                                        .addGap(12, 12, 12)
                                        .addComponent(slQuality, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                                    .addGroup(pnlOutputFormatLayout.createSequentialGroup()
                                        .addComponent(rbPNG)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED))
                                    .addGroup(pnlOutputFormatLayout.createSequentialGroup()
                                        .addComponent(lblImageFormats)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)))))
                        .addGap(234, 234, 234))
                    .addComponent(lblOutputFormat)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlOutputFormatLayout.createSequentialGroup()
                        .addComponent(edtOutput, javax.swing.GroupLayout.DEFAULT_SIZE, 624, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnBrowseOutput, javax.swing.GroupLayout.PREFERRED_SIZE, 31, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addComponent(lblSelectOutput))
                .addContainerGap())
        );
        pnlOutputFormatLayout.setVerticalGroup(
            pnlOutputFormatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlOutputFormatLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblOutputFormat)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(pnlOutputFormatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(lblTextFormats)
                    .addGroup(pnlOutputFormatLayout.createSequentialGroup()
                        .addGap(22, 22, 22)
                        .addComponent(rbHTML)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(rbHTMLCSS)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(rbRTF)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(pnlOutputFormatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(rbTXT)
                    .addComponent(lblDetails)
                    .addComponent(slDetails, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addGap(18, 18, 18)
                .addComponent(lblImageFormats)
                .addGap(8, 8, 8)
                .addComponent(rbBMP)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlOutputFormatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(rbJPG)
                    .addComponent(lblQuality)
                    .addComponent(slQuality, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(rbPNG)
                .addGap(18, 18, 18)
                .addComponent(lblSelectOutput)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnlOutputFormatLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnBrowseOutput)
                    .addComponent(edtOutput, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        tpWizard.addTab(lang.getString("Tab_Output"), pnlOutputFormat); // NOI18N

        lblSummary.setText(lang.getString("Step_Summary")); // NOI18N

        taSummary.setBackground(javax.swing.UIManager.getDefaults().getColor("Viewport.background"));
        taSummary.setColumns(20);
        taSummary.setEditable(false);
        taSummary.setRows(5);
        spSummary.setViewportView(taSummary);

        btnGenerateASCII.setText(lang.getString("Generate_Ascii")); // NOI18N
        btnGenerateASCII.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnGenerateASCIIActionPerformed(evt);
            }
        });

        btnCancelASCII.setText(lang.getString("Cancel_Ascii")); // NOI18N
        btnCancelASCII.setEnabled(false);
        btnCancelASCII.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCancelASCIIActionPerformed(evt);
            }
        });

        lblProgress.setText(lang.getString("Ready")); // NOI18N

        javax.swing.GroupLayout pnlOutputLayout = new javax.swing.GroupLayout(pnlOutput);
        pnlOutput.setLayout(pnlOutputLayout);
        pnlOutputLayout.setHorizontalGroup(
            pnlOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, pnlOutputLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnlOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(pbProgress, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 640, Short.MAX_VALUE)
                    .addComponent(spSummary, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 640, Short.MAX_VALUE)
                    .addComponent(lblSummary, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, pnlOutputLayout.createSequentialGroup()
                        .addComponent(btnGenerateASCII)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(btnCancelASCII))
                    .addComponent(lblProgress, javax.swing.GroupLayout.Alignment.LEADING))
                .addContainerGap())
        );
        pnlOutputLayout.setVerticalGroup(
            pnlOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnlOutputLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblSummary)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(spSummary, javax.swing.GroupLayout.PREFERRED_SIZE, 241, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addGroup(pnlOutputLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnGenerateASCII)
                    .addComponent(btnCancelASCII))
                .addGap(18, 18, 18)
                .addComponent(lblProgress)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(pbProgress, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(31, Short.MAX_VALUE))
        );

        tpWizard.addTab(lang.getString("Tab_Summary"), pnlOutput); // NOI18N

        btnExit.setText(lang.getString("Exit")); // NOI18N
        btnExit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnExitActionPerformed(evt);
            }
        });

        btnNext.setText(lang.getString("Next")); // NOI18N
        btnNext.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnNextActionPerformed(evt);
            }
        });

        btnBack.setText(lang.getString("Back")); // NOI18N
        btnBack.setEnabled(false);
        btnBack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBackActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(tpWizard, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, 669, Short.MAX_VALUE)
                    .addComponent(lblWelcome, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(btnBack, javax.swing.GroupLayout.PREFERRED_SIZE, 101, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btnNext, javax.swing.GroupLayout.PREFERRED_SIZE, 97, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addGap(73, 73, 73)
                        .addComponent(lblCopyright, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 94, Short.MAX_VALUE)
                        .addComponent(btnExit, javax.swing.GroupLayout.PREFERRED_SIZE, 89, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(lblWelcome)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(tpWizard, javax.swing.GroupLayout.PREFERRED_SIZE, 422, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 15, Short.MAX_VALUE)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btnExit)
                    .addComponent(btnBack)
                    .addComponent(btnNext)
                    .addComponent(lblCopyright, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents
    private void btnBrowseOutputActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBrowseOutputActionPerformed
        JFileChooser chooser = initializeDialog(new String[]{"html", "rtf",
                    "txt", "bmp", "jpg", "png"
                }, lang.getString("Supported_Output_Formats"));
        if (chooser.showSaveDialog(this) == JFileChooser.APPROVE_OPTION) {
            controller.setOutputFile(chooser.getSelectedFile());
            edtOutput.setText(controller.getOutputFile());
            updateOutputFilename();
        }
    }//GEN-LAST:event_btnBrowseOutputActionPerformed

    /**
     * Tries to display the next wizard page and updates the button states.
     * @param evt Not used.
     */
    private void btnNextActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnNextActionPerformed
        controller.nextStep();
        updateButtonStates();
    }//GEN-LAST:event_btnNextActionPerformed

    /**
     * Tries to display the previous wizard page and updates the button states.
     * @param evt Not used.
     */
    private void btnBackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBackActionPerformed
        controller.previousStep();
        updateButtonStates();
    }//GEN-LAST:event_btnBackActionPerformed

    /**
     * Exits the application via the controller.
     * @param evt Not used.
     */
    private void btnExitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnExitActionPerformed
        controller.exit();
    }//GEN-LAST:event_btnExitActionPerformed

    /**
     * Updates the previewlabel font and repaints it.
     * @param evt Not used.
     */
    private void chkBoldItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkBoldItemStateChanged
        lblPreview.setFont(new Font((String) cbFont.getSelectedItem(),
                chkBold.isSelected() ? Font.BOLD : Font.PLAIN, 14));
        lblPreview.repaint();
    }//GEN-LAST:event_chkBoldItemStateChanged

    /**
     * Updates the previewlabel font and repaints it.
     * @param evt Not used.
     */
    private void cbFontItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_cbFontItemStateChanged
        lblPreview.setFont(new Font((String) cbFont.getSelectedItem(),
                Font.PLAIN, 14));
        lblPreview.repaint();
    }//GEN-LAST:event_cbFontItemStateChanged

    /**
     * Sets the resize gui element states.
     * @param evt Not used.
     */
    private void chkResizeItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkResizeItemStateChanged
        edtWidth.setEnabled(chkResize.isSelected());
        edtHeight.setEnabled(chkResize.isSelected());
        chkAspectRatio.setEnabled(chkResize.isSelected());
    }//GEN-LAST:event_chkResizeItemStateChanged

    /**
     * Sets the quantize gui element states.
     * @param evt Not used.
     */
    private void chkQuantizeItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkQuantizeItemStateChanged
        edtColorCount.setEnabled(chkQuantize.isSelected());
    }//GEN-LAST:event_chkQuantizeItemStateChanged

    /**
     * Opens an open dialog to choose an input image. Tries to load the
     * selected image.
     * @param evt Not used.
     */
    private void btnBrowseInputActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBrowseInputActionPerformed
        JFileChooser chooser = initializeDialog(new String[]{"bmp", "gif",
                    "jpg", "png"
                }, lang.getString("Supported_Input_Formats"));
        chooser.setCurrentDirectory(new File(controller.getInputFile()));
        if (chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
            openImage(chooser.getSelectedFile());
    }//GEN-LAST:event_btnBrowseInputActionPerformed

    /**
     * Try to load the image file if the enter key is pressed.
     * @param evt Not used.
     */
    private void edtInputKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_edtInputKeyPressed
        if (evt.getKeyCode() == java.awt.event.KeyEvent.VK_ENTER)
            openImage(new File(edtInput.getText()));
    }//GEN-LAST:event_edtInputKeyPressed

    /**
     * Reset the text to the default one, if the text is empty.
     * @param evt Not used.
     */
    private void edtCustomTextFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_edtCustomTextFocusLost
        if (edtCustomText.getText().equals(""))
            edtCustomText.setText("JASCiiArt");
    }//GEN-LAST:event_edtCustomTextFocusLost

    /**
     * Reset the text to the default one, if the text is empty.
     * @param evt Not used.
     */
    private void edtBrightnessFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_edtBrightnessFocusLost
        if (edtBrightness.getText().equals(""))
            edtBrightness.setText("JASCiiArt");
    }//GEN-LAST:event_edtBrightnessFocusLost

    /**
     * Only allow digits in the textfield and accept only valid numbers.
     * @param evt Not used.
     */
    private void edtLowerRangeFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_edtLowerRangeFocusLost
        parseVerifyString(edtLowerRange, 123, 1, 255);
    }//GEN-LAST:event_edtLowerRangeFocusLost

    /**
     * Only allow digits in the textfield and accept only valid numbers.
     * @param evt Not used.
     */
    private void edtUpperRangeFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_edtUpperRangeFocusLost
        parseVerifyString(edtUpperRange, 254, 1, 255);
    }//GEN-LAST:event_edtUpperRangeFocusLost

    /**
     * Only allow digits in the textfield and accept only valid numbers.
     * @param evt Not used.
     */
    private void edtFontSizeFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_edtFontSizeFocusLost
        parseVerifyString(edtFontSize, 8, 1, 1000);
    }//GEN-LAST:event_edtFontSizeFocusLost

    /**
     * Only allow digits in the textfield and accept only valid numbers.
     * @param evt Not used.
     */
    private void edtColorCountFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_edtColorCountFocusLost
        parseVerifyString(edtColorCount, 256, 1, 1000000000);
    }//GEN-LAST:event_edtColorCountFocusLost

    /**
     * Only allow digits in the textfield and accept only valid numbers.
     * If the content was deleted and restored the width needs to be updated.
     * @param evt Not used.
     */
    private void edtWidthFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_edtWidthFocusLost
        parseVerifyString(edtWidth, controller.getImageEditor().getWidth(), 1, 10000);
        edtWidthKeyReleased(null);
    }//GEN-LAST:event_edtWidthFocusLost

    /**
     * Only allow digits in the textfield and accept only valid numbers.
     * If the content was deleted and restored the width needs to be updated.
     * @param evt Not used.
     */
    private void edtHeightFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_edtHeightFocusLost
        parseVerifyString(edtHeight, controller.getImageEditor().getHeight(), 1, 10000);
        edtHeightKeyReleased(null);
    }//GEN-LAST:event_edtHeightFocusLost

    /**
     * Initializes all needed variables for a successful ascii picture
     * generation. Afterwards the controller is advised to start the conversion
     * process.
     * @param evt Not used.
     */
    private void btnGenerateASCIIActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnGenerateASCIIActionPerformed
        controller.setTransformationInfo(new ImageTransformationInfo(
                chkResize.isSelected(), Integer.parseInt(edtWidth.getText()),
                Integer.parseInt(edtHeight.getText()), chkGrayscale.isSelected(),
                chkQuantize.isSelected(), Integer.parseInt(edtColorCount.getText())));

        DataProvider dp = new DataProvider(Integer.parseInt(edtFontSize.getText()) > 1);
        Enumeration<AbstractButton> e = btngrpDesign.getElements();
        for (int i = 0; i < btngrpDesign.getButtonCount() && e.hasMoreElements(); i++)
            if (e.nextElement().isSelected()) {
                dp.setMode(i);
                break;
            }
        if (dp.getMode() == DataProvider.DATA_CUSTOMTEXT)
            dp.setText(edtCustomText.getText());
        else if (dp.getMode() == DataProvider.DATA_BRIGHTNESSPATTERN)
            dp.setText(edtBrightness.getText());
        else
            dp.setText("");
        dp.setCustomCharBegin(Integer.parseInt(edtLowerRange.getText()));
        dp.setCustomCharEnd(Integer.parseInt(edtUpperRange.getText()));
        if (rbCustomText.isSelected() && chkCustomTextRandom.isSelected())
            dp.setMode(DataProvider.DATA_RANDOMCUSTOMTEXT);
        controller.setDataProvider(dp);

        e = btngrpOutputFormat.getElements();
        for (int i = 0; i < btngrpOutputFormat.getButtonCount() && e.hasMoreElements(); i++)
            if (e.nextElement().isSelected()) {
                int quality = (rbTXT.isSelected() ? slDetails.getValue() - 1 : slQuality.getValue());
                controller.setOutputInfo(new OutputInfo(
                        new Font((String) cbFont.getSelectedItem(),
                        chkBold.isSelected() ? Font.BOLD : Font.PLAIN,
                        Integer.parseInt(edtFontSize.getText())),
                        cpBackground.getBackColor(), i, quality));
                break;
            }

        controller.startConversion();
    }//GEN-LAST:event_btnGenerateASCIIActionPerformed

    /**
     * Updates the height textfield according to the aspect ratio if the width
     * value was changed.
     * @param evt Not used.
     */
    private void edtWidthKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_edtWidthKeyReleased
        if (chkAspectRatio.isSelected() && !edtWidth.getText().equals(""))
            edtHeight.setText(Integer.toString(
                    (int) Math.round(Integer.parseInt(edtWidth.getText()) /
                    controller.getImageEditor().getRatio())));
    }//GEN-LAST:event_edtWidthKeyReleased

    /**
     * Just update the width and height textfields.
     * @param evt Not used.
     */
    private void chkAspectRatioItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_chkAspectRatioItemStateChanged
        edtWidthKeyReleased(null);
    }//GEN-LAST:event_chkAspectRatioItemStateChanged

    /**
     * Updates the width textfield according to the aspect ratio if the height
     * value was changed.
     * @param evt Not used.
     */
    private void edtHeightKeyReleased(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_edtHeightKeyReleased
        if (chkAspectRatio.isSelected() && !edtHeight.getText().equals(""))
            edtWidth.setText(Integer.toString(
                    (int) Math.round(Integer.parseInt(edtHeight.getText()) *
                    controller.getImageEditor().getRatio())));
    }//GEN-LAST:event_edtHeightKeyReleased

    /**
     * When the wizard page is changed the back and next button states need to
     * be updated.
     * @param evt Not used.
     */
    private void tpWizardStateChanged(javax.swing.event.ChangeEvent evt) {//GEN-FIRST:event_tpWizardStateChanged
        updateButtonStates();
    }//GEN-LAST:event_tpWizardStateChanged

    /**
     * Tries to load the input file if the input filename was manually edited.
     * @param evt Not used.
     */
    private void edtInputFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_edtInputFocusLost
        if (!edtInput.getText().equals(controller.getInputFile()))
            openImage(new File(edtInput.getText()));
    }//GEN-LAST:event_edtInputFocusLost

    /**
     * If the output filename was manually edited the controllers output file
     * is set to the new one.
     * @param evt Not used.
     */
    private void edtOutputFocusLost(java.awt.event.FocusEvent evt) {//GEN-FIRST:event_edtOutputFocusLost
        if (!edtOutput.getText().equals(controller.getOutputFile()))
            controller.setOutputFile(new File(edtOutput.getText()));
}//GEN-LAST:event_edtOutputFocusLost

    /**
     * Toggles the visibility of the plain text detail controls and updates
     * the output filename to append the right extension.
     * @param evt Not used.
     */
    private void rbTXTItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_rbTXTItemStateChanged
        lblDetails.setVisible(rbTXT.isSelected());
        slDetails.setVisible(rbTXT.isSelected());
        updateOutputFilename();
    }//GEN-LAST:event_rbTXTItemStateChanged

    /**
     * Toggles the visibility of the JPG quality controls and updates
     * the output filename to append the right extension.
     * @param evt Not used.
     */
    private void rbJPGItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_rbJPGItemStateChanged
        lblQuality.setVisible(rbJPG.isSelected());
        slQuality.setVisible(rbJPG.isSelected());
        updateOutputFilename();
    }//GEN-LAST:event_rbJPGItemStateChanged

    /**
     * Updates the output filename to append the right extension.
     * @param evt Not used.
     */
    private void rbHTMLItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_rbHTMLItemStateChanged
        updateOutputFilename();
    }//GEN-LAST:event_rbHTMLItemStateChanged

    /**
     * Updates the output filename to append the right extension.
     * @param evt Not used.
     */
    private void rbHTMLCSSItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_rbHTMLCSSItemStateChanged
        updateOutputFilename();
    }//GEN-LAST:event_rbHTMLCSSItemStateChanged

    /**
     * Updates the output filename to append the right extension.
     * @param evt Not used.
     */
    private void rbRTFItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_rbRTFItemStateChanged
        updateOutputFilename();
    }//GEN-LAST:event_rbRTFItemStateChanged

    /**
     * Updates the output filename to append the right extension.
     * @param evt Not used.
     */
    private void rbBMPItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_rbBMPItemStateChanged
        updateOutputFilename();
    }//GEN-LAST:event_rbBMPItemStateChanged

    /**
     * Updates the output filename to append the right extension.
     * @param evt Not used.
     */
    private void rbPNGItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_rbPNGItemStateChanged
        updateOutputFilename();
    }//GEN-LAST:event_rbPNGItemStateChanged

    /**
     * Stops the conversion process.
     * @param evt Not used.
     */
    private void btnCancelASCIIActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCancelASCIIActionPerformed
        controller.stopConversion();
    }//GEN-LAST:event_btnCancelASCIIActionPerformed

    /**
     * Loads custom text.
     * @param evt Not used.
     */
    private void btnBrowseTextActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBrowseTextActionPerformed
        JFileChooser chooser = initializeDialog(new String[]{"txt"},
                lang.getString("Supported_Text_Formats"));
        chooser.setCurrentDirectory(new File(controller.getInputFile()));
        if (chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION)
            try {
                BufferedReader fileReader = new BufferedReader(
                        new FileReader(chooser.getSelectedFile()));
                String line, text = "";
                while ((line = fileReader.readLine()) != null)
                    text += line;
                edtCustomText.setText(text);
                fileReader.close();
            } catch (IOException e) {
                errorMessage(lang.getString("Error_Reading_File"), e);
            }
}//GEN-LAST:event_btnBrowseTextActionPerformed

    /**
     * Enables the custom text controls if custom text mode is selected.
     * @param evt Not used.
     */
    private void rbCustomTextItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_rbCustomTextItemStateChanged
        edtCustomText.setEnabled(rbCustomText.isSelected());
        btnBrowseText.setEnabled(rbCustomText.isSelected());
        chkCustomTextRandom.setEnabled(rbCustomText.isSelected());
    }//GEN-LAST:event_rbCustomTextItemStateChanged

    /**
     * Enables the brightness pattern controls if brightness mode is selected.
     * @param evt Not used.
     */
    private void rbBrightnessItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_rbBrightnessItemStateChanged
        edtBrightness.setEnabled(rbBrightness.isSelected());
    }//GEN-LAST:event_rbBrightnessItemStateChanged

    /**
     * Enables the custom char range controls if custom char range mode is
     * selected.
     * @param evt Not used.
     */
    private void rbCharactersItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_rbCharactersItemStateChanged
        edtLowerRange.setEnabled(rbCharacters.isSelected());
        edtUpperRange.setEnabled(rbCharacters.isSelected());
    }//GEN-LAST:event_rbCharactersItemStateChanged

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnBack;
    private javax.swing.JButton btnBrowseInput;
    private javax.swing.JButton btnBrowseOutput;
    private javax.swing.JButton btnBrowseText;
    private javax.swing.JButton btnCancelASCII;
    private javax.swing.JButton btnExit;
    private javax.swing.JButton btnGenerateASCII;
    private javax.swing.JButton btnNext;
    private javax.swing.ButtonGroup btngrpDesign;
    private javax.swing.ButtonGroup btngrpOutputFormat;
    private javax.swing.JComboBox cbFont;
    private javax.swing.JCheckBox chkAspectRatio;
    private javax.swing.JCheckBox chkBold;
    private javax.swing.JCheckBox chkCustomTextRandom;
    private javax.swing.JCheckBox chkGrayscale;
    private javax.swing.JCheckBox chkQuantize;
    private javax.swing.JCheckBox chkResize;
    private ui.graphical.controls.JColorPanel cpBackground;
    private javax.swing.JTextField edtBrightness;
    private javax.swing.JTextField edtColorCount;
    private javax.swing.JTextField edtCustomText;
    private javax.swing.JTextField edtFontSize;
    private javax.swing.JTextField edtHeight;
    private javax.swing.JTextField edtInput;
    private javax.swing.JTextField edtLowerRange;
    private javax.swing.JTextField edtOutput;
    private javax.swing.JTextField edtUpperRange;
    private javax.swing.JTextField edtWidth;
    private javax.swing.JLabel lblBackground;
    private javax.swing.JLabel lblColorNotice;
    private ui.graphical.controls.JCopyrightLabel lblCopyright;
    private javax.swing.JLabel lblDescAspectRatio;
    private javax.swing.JLabel lblDescBrightness;
    private javax.swing.JLabel lblDescPreview;
    private javax.swing.JLabel lblDescSize;
    private javax.swing.JLabel lblDescTimes;
    private javax.swing.JLabel lblDetails;
    private javax.swing.JLabel lblFont;
    private javax.swing.JLabel lblFontSize;
    private javax.swing.JLabel lblFontUnit;
    private javax.swing.JLabel lblImageFormats;
    private javax.swing.JLabel lblInfoAspectRatio;
    private javax.swing.JLabel lblInfoSize;
    private javax.swing.JLabel lblModifyInput;
    private javax.swing.JLabel lblOutputFormat;
    private javax.swing.JLabel lblPattern;
    private javax.swing.JLabel lblPreview;
    private javax.swing.JLabel lblProgress;
    private javax.swing.JLabel lblQuality;
    private javax.swing.JLabel lblSelectInput;
    private javax.swing.JLabel lblSelectOutput;
    private javax.swing.JLabel lblSummary;
    private javax.swing.JLabel lblTextFormats;
    private javax.swing.JLabel lblTo;
    private javax.swing.JLabel lblWelcome;
    private javax.swing.JProgressBar pbProgress;
    private javax.swing.JPanel pnlDesign;
    private javax.swing.JPanel pnlInput;
    private javax.swing.JPanel pnlOutput;
    private javax.swing.JPanel pnlOutputFormat;
    private ui.graphical.controls.JImagePanel pnlPreview;
    private javax.swing.JRadioButton rbBMP;
    private javax.swing.JRadioButton rbBinary;
    private javax.swing.JRadioButton rbBrightness;
    private javax.swing.JRadioButton rbCharacters;
    private javax.swing.JRadioButton rbCustomText;
    private javax.swing.JRadioButton rbHTML;
    private javax.swing.JRadioButton rbHTMLCSS;
    private javax.swing.JRadioButton rbJPG;
    private javax.swing.JRadioButton rbLowercase;
    private javax.swing.JRadioButton rbNumbers;
    private javax.swing.JRadioButton rbPNG;
    private javax.swing.JRadioButton rbRTF;
    private javax.swing.JRadioButton rbTXT;
    private javax.swing.JRadioButton rbUppercase;
    private javax.swing.JSlider slDetails;
    private javax.swing.JSlider slQuality;
    private javax.swing.JScrollPane spSummary;
    private javax.swing.JTextArea taSummary;
    private javax.swing.JTabbedPane tpWizard;
    // End of variables declaration//GEN-END:variables

    /** Controls the state of the back and next button of the wizard. */
    private void updateButtonStates() {
        if (btnBack != null && btnNext != null && controller != null) {
            btnBack.setEnabled(getStep() > Controller.STEP_INPUT);
            btnNext.setEnabled(getStep() < Controller.STEP_SUMMARY);
        }
    }

    /**
     * This function tries to load the specified image file and sets the
     * corresponding options of the gui elements. If the file does not exist
     * an error dialog is shown.
     * @param f The image file to load.
     */
    private void openImage(File f) {
        if (f.exists()) {
            boolean valid = controller.loadImage(f);
            chkResize.setEnabled(valid);
            chkQuantize.setEnabled(valid);
            chkGrayscale.setEnabled(valid);
            pnlPreview.setImage(controller.getImage());
            edtWidth.setText(Integer.toString(controller.getImageEditor().getWidth()));
            edtHeight.setText(Integer.toString(controller.getImageEditor().getHeight()));
            edtInput.setText(controller.getInputFile());
            lblInfoSize.setText(edtWidth.getText() + " x " + edtHeight.getText());
            lblInfoAspectRatio.setText(
                    controller.getImageEditor().getHeight() == 0 ? "0" : Double.toString((double) controller.getImageEditor().getWidth() /
                    (double) controller.getImageEditor().getHeight()));
            cpBackground.setBackColor(new Color(
                    controller.getImageEditor().getImage().getRGB(0, 0)));
        } else {
            errorMessage(lang.getString("Error_Input_Does_Not_Exist"), null);
            edtInput.setText(controller.getInputFile());
        }
    }

    /**
     * Reads a JTextField text and sets it to the default value if the text is
     * empty. If the text is not empty but the value if smaller than the minimum
     * or greater than the maximum value, the value is reset to the default
     * value.
     * @param tf The target textfield.
     * @param default_value The default value.
     * @param min The minimum value.
     * @param max The maximum value.
     */
    private void parseVerifyString(JTextField tf, int default_value,
            int min, int max) {
        final String def = Integer.toString(default_value);
        if (tf.getText().equals(""))
            tf.setText(def);
        else {
            int val = Integer.parseInt(extractDigits(tf.getText()));
            tf.setText(val < min || val > max ? def : Integer.toString(val));
        }
    }

    /**
     * Updates the output filename. The functions appends the correct extension
     * to the filename.
     */
    private void updateOutputFilename() {
        String original = controller.getOutputFile();
        if (original != null) {
            int pos = original.lastIndexOf(".");
            if (pos < 0)
                pos = original.length();
            String filenameWithoutExt = original.substring(0, pos);
            Enumeration<AbstractButton> e = btngrpOutputFormat.getElements();
            for (int i = 0; i < btngrpOutputFormat.getButtonCount() && e.hasMoreElements(); i++)
                if (e.nextElement().isSelected()) {
                    controller.setOutputFile(new File(filenameWithoutExt + "." + OutputInfo.extensions[i]));
                    edtOutput.setText(controller.getOutputFile());
                    break;
                }

        }
    }

    /**
     * Filters all digits out of a string.
     * @param input Input string from which the digits are extracted.
     * @return All digits in the String.
     */
    private String extractDigits(String input) {
        String res = "";
        for (char c : input.toCharArray())
            if (Character.isDigit(c))
                res += c;
        return res;
    }

    /**
     * Initializes the file chooser with the specified formats.
     * @param formats The allowed file formats.
     * @param description The description of the file formats.
     * @return The initialized file chooser.
     */
    public JFileChooser initializeDialog(String[] formats, String description) {
        JFileChooser chooser = new JFileChooser();
        chooser.setCurrentDirectory(new File(edtInput.getText()));
        chooser.addChoosableFileFilter(new FileDialogFilter(formats, description));
        return chooser;
    }

    /**
     * Displays an error message and prints the stack-trace.
     * @param message The error message.
     * @param e The exception which gets printed in the console.
     */
    public void errorMessage(String message, Exception e) {
        JOptionPane.showMessageDialog(null, message, lang.getString("Error"), JOptionPane.ERROR_MESSAGE);
        if (e != null)
            e.printStackTrace();
    }

    /**
     * Changes the label caption to the current status.
     * @param message Current status.
     */
    public void statusMessage(String message) {
        lblProgress.setText(message);
    }

    /**
     * Resets the ProgressBar value and disables the buttons to start a new
     * conversion.
     */
    public void startedConversion() {
        btnGenerateASCII.setEnabled(false);
        btnCancelASCII.setEnabled(true);
        pbProgress.setValue(0);
    }

    /** Reenables the buttons after a conversion and fills up the ProgressBar. */
    public void finishedConversion() {
        btnGenerateASCII.setEnabled(true);
        btnCancelASCII.setEnabled(false);
        pbProgress.setValue(pbProgress.getMaximum());
    }

    /**
     * Returns the maximum value of the ProgressBar.
     * @return The maximum value.
     */
    public int getMaxProgress() {
        return pbProgress.getMaximum();
    }

    /**
     * Sets the maximum value of the ProgressBar.
     * @param progress Maximum value.
     */
    public void setMaxProgress(int progress) {
        pbProgress.setMaximum(progress);
    }

    /**
     * Returns the current value of the ProgressBar.
     * @return Current value.
     */
    public int getProgress() {
        return pbProgress.getValue();
    }

    /**
     * Sets the current value of the ProgressBar.
     * @param progress New current value.
     */
    public void setProgress(int progress) {
        pbProgress.setValue(progress);
        lblProgress.setText(String.format(lang.getString("Processing_Scanline"), progress,
                pbProgress.getMaximum()));
    }

    /**
     * Returns the current active page in the TabbedPane.
     * @return Current wizard page.
     */
    public int getStep() {
        return tpWizard.getSelectedIndex();
    }

    /**
     * Returns the page count in the TabbedPane component.
     * @return Component count in the wizard container.
     */
    public int getMaxSteps() {
        return tpWizard.getComponentCount() - 1;
    }

    /**
     * Sets the current wizard step, the active page in the TabbedPane component.
     * @param step Target wizard page.
     */
    public void setStep(int step) {
        tpWizard.setSelectedIndex(step);
    }
}
